var ant = (function (exports, CronCore, iconsVue, vue) {
  'use strict';

  function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

  var CronCore__default = /*#__PURE__*/_interopDefaultLegacy(CronCore);

  var script$1 = {
    inheritAttrs: false,
    components: {
      RenderlessSelect: CronCore.RenderlessSelect,
      CloseCircleFilled: iconsVue.CloseCircleFilled
    },
    name: 'CustomSelect',
    props: {
      buttonProps: {
        type: Object,
        default: () => {}
      },
      dropdownProps: {
        type: Object,
        default: () => {}
      },
      hideOnClick: {
        type: Boolean,
        default: true
      }
    },
    data: () => {
      return {
        visible: false
      }
    },
    emits: ['update:model-value'],
    methods: {
      updateVisibility () {
        if (this.hideOnClick && this.visible) {
          this.visible = false;
        }
      }
    }
  };

  const _hoisted_1$1 = { class: "custom-select" };

  function render$1(_ctx, _cache, $props, $setup, $data, $options) {
    const _component_CloseCircleFilled = vue.resolveComponent("CloseCircleFilled");
    const _component_a_button = vue.resolveComponent("a-button");
    const _component_a_menu_item = vue.resolveComponent("a-menu-item");
    const _component_a_menu = vue.resolveComponent("a-menu");
    const _component_a_dropdown = vue.resolveComponent("a-dropdown");
    const _component_renderless_select = vue.resolveComponent("renderless-select");

    return (vue.openBlock(), vue.createBlock(_component_renderless_select, vue.mergeProps(_ctx.$attrs, {
      "onUpdate:modelValue": _cache[2] || (_cache[2] = $event => (_ctx.$emit('update:model-value', $event)))
    }), {
      default: vue.withCtx(({ selectedStr, itemRows, select, clearable, clear, modelValue, itemValue }) => [
        vue.createElementVNode("span", _hoisted_1$1, [
          vue.createVNode(_component_a_dropdown, vue.mergeProps({
            trigger: ['click'],
            open: _ctx.visible,
            "onUpdate:open": _cache[1] || (_cache[1] = $event => ((_ctx.visible) = $event))
          }, $props.dropdownProps), {
            overlay: vue.withCtx(() => [
              vue.createVNode(_component_a_menu, {
                multiple: "",
                selectedKeys: Array.isArray(modelValue) ? modelValue : [modelValue]
              }, {
                default: vue.withCtx(() => [
                  (vue.openBlock(true), vue.createElementBlock(vue.Fragment, null, vue.renderList(itemRows, (itemRow, i) => {
                    return (vue.openBlock(), vue.createElementBlock("div", {
                      class: "vcron-a-row",
                      type: "flex",
                      key: i
                    }, [
                      (vue.openBlock(true), vue.createElementBlock(vue.Fragment, null, vue.renderList(itemRow, (item, j) => {
                        return (vue.openBlock(), vue.createElementBlock("div", {
                          class: "vcron-a-col",
                          flex: 1,
                          key: j
                        }, [
                          item
                            ? (vue.openBlock(), vue.createBlock(_component_a_menu_item, {
                                key: item[itemValue],
                                onClick: $event => {select(item); $options.updateVisibility();}
                              }, {
                                default: vue.withCtx(() => [
                                  vue.createTextVNode(vue.toDisplayString(item.text), 1 /* TEXT */)
                                ]),
                                _: 2 /* DYNAMIC */
                              }, 1032 /* PROPS, DYNAMIC_SLOTS */, ["onClick"]))
                            : (vue.openBlock(), vue.createBlock(_component_a_menu_item, { key: 1 }))
                        ]))
                      }), 128 /* KEYED_FRAGMENT */))
                    ]))
                  }), 128 /* KEYED_FRAGMENT */))
                ]),
                _: 2 /* DYNAMIC */
              }, 1032 /* PROPS, DYNAMIC_SLOTS */, ["selectedKeys"])
            ]),
            default: vue.withCtx(() => [
              vue.createVNode(_component_a_button, vue.normalizeProps(vue.guardReactiveProps($props.buttonProps)), {
                default: vue.withCtx(() => [
                  vue.createTextVNode(vue.toDisplayString(selectedStr), 1 /* TEXT */),
                  clearable
                    ? (vue.openBlock(), vue.createBlock(_component_CloseCircleFilled, {
                        key: 0,
                        onClick: [
                          $event => (clear()),
                          _cache[0] || (_cache[0] = vue.withModifiers(() => {}, ["stop"]))
                        ]
                      }, null, 8 /* PROPS */, ["onClick"]))
                    : vue.createCommentVNode("v-if", true)
                ]),
                _: 2 /* DYNAMIC */
              }, 1040 /* FULL_PROPS, DYNAMIC_SLOTS */)
            ]),
            _: 2 /* DYNAMIC */
          }, 1040 /* FULL_PROPS, DYNAMIC_SLOTS */, ["open"])
        ])
      ]),
      _: 1 /* STABLE */
    }, 16 /* FULL_PROPS */))
  }

  script$1.render = render$1;
  script$1.__scopeId = "data-v-04350d06";
  script$1.__file = "src/components/CustomSelect.vue";

  var script = {
    name: 'VueCronEditor',
    components: {
      CronCore: CronCore__default["default"].component,
      CustomSelect: script$1
    },
    props: {
      buttonProps: {
        type: Object,
        default () {
          return {}
        }
      },
      cols: {
        type: Object,
        default: () => {
          return {
            minute: 5,
            hour: 4,
            day: 4
          }
        }
      }
    },
    emits: ['update:model-value', 'error']
  };

  const _hoisted_1 = { class: "vcron-a-spacer" };
  const _hoisted_2 = { class: "vcron-a-spacer" };

  function render(_ctx, _cache, $props, $setup, $data, $options) {
    const _component_custom_select = vue.resolveComponent("custom-select");
    const _component_CronCore = vue.resolveComponent("CronCore");

    return (vue.openBlock(), vue.createBlock(_component_CronCore, vue.mergeProps(_ctx.$attrs, {
      "onUpdate:modelValue": _cache[0] || (_cache[0] = $event => (_ctx.$emit('update:model-value', $event))),
      onError: _cache[1] || (_cache[1] = $event => (_ctx.$emit('error', $event)))
    }), {
      default: vue.withCtx(({fields, period}) => [
        vue.createElementVNode("div", null, [
          vue.createTextVNode(vue.toDisplayString(period.prefix) + " ", 1 /* TEXT */),
          vue.createElementVNode("div", _hoisted_1, [
            vue.createVNode(_component_custom_select, vue.mergeProps(period.attrs, {
              items: period.items
            }, vue.toHandlers(period.events), {
              "item-value": "id",
              "button-props": $props.buttonProps
            }), null, 16 /* FULL_PROPS */, ["items", "button-props"])
          ]),
          vue.createTextVNode(" " + vue.toDisplayString(period.suffix) + " ", 1 /* TEXT */),
          (vue.openBlock(true), vue.createElementBlock(vue.Fragment, null, vue.renderList(fields, (f) => {
            return (vue.openBlock(), vue.createElementBlock(vue.Fragment, {
              key: f.id
            }, [
              vue.createTextVNode(vue.toDisplayString(f.prefix) + " ", 1 /* TEXT */),
              vue.createElementVNode("div", _hoisted_2, [
                vue.createVNode(_component_custom_select, vue.mergeProps(f.attrs, vue.toHandlers(f.events), {
                  selection: f.selectedStr,
                  cols: $props.cols[f.id],
                  items: f.items,
                  multiple: "",
                  "button-props": $props.buttonProps,
                  hideOnClick: false,
                  clearable: ""
                }), null, 16 /* FULL_PROPS */, ["selection", "cols", "items", "button-props"])
              ]),
              vue.createTextVNode(" " + vue.toDisplayString(f.suffix), 1 /* TEXT */)
            ], 64 /* STABLE_FRAGMENT */))
          }), 128 /* KEYED_FRAGMENT */))
        ])
      ]),
      _: 1 /* STABLE */
    }, 16 /* FULL_PROPS */))
  }

  script.render = render;
  script.__file = "src/CronEditor.vue";

  // Import vue component

  // Declare install function executed by Vue.use()
  function install (Vue) {
    if (install.installed) return
    install.installed = true;
    Vue.component('CronAnt', script);
  }

  // Create module definition for Vue.use()
  const plugin = {
    install,
    component: script,
    util: CronCore__default["default"].util
  };

  exports.CronAnt = script;
  exports.CronAntPlugin = plugin;
  exports["default"] = plugin;
  exports.install = install;

  Object.defineProperty(exports, '__esModule', { value: true });

  return exports;

})({}, CronCore, iconsVue, vue);
